SystemOrganization addCategory: #ComanchePatch!

!HttpRequest class methodsFor: '*ComanchePatch' stamp: 'sebastiansastre 1/8/2014 09:46'!
decodeUrlEncodedForm: string multipleValues: boolean
	| dict key value start end eqSignPos more |
	dict := boolean ifTrue: [HttpFormDictionary new] ifFalse: [Dictionary new].
	string isEmptyOrNil ifTrue: [^dict].
	more := true.
	start := 1.
	[end := string indexOf: $& startingAt: start.
	end == 0
		ifTrue: [end := string size. more := false]
		ifFalse: [end := end - 1].
	eqSignPos := string indexOf: $= startingAt: start.
	(eqSignPos > end or: [eqSignPos == 0])
		ifTrue: [key := (key := string copyFrom: start to: end) urlDecoded.
			value := '']
		ifFalse: [key := (key := string copyFrom: start to: eqSignPos-1) urlDecoded.
			value := (value := string copyFrom: eqSignPos+1 to: end) urlDecoded].
	self addKey: key value: value toForm: dict multipleValues: boolean.
	start := end + 2.
	dict size > self maxDictionarySize
		ifTrue: [ ^ dict ].
	more] whileTrue.

	^dict! !

!HttpRequest class methodsFor: '*ComanchePatch' stamp: 'SebastianSastre 1/15/2012 16:23'!
parseHttpHeader: string
	| dict key value start end more colonPos fieldDelims lastKey keyValueDelim crlf |
	dict := Dictionary new.
	crlf := String crlf.
	string isEmptyOrNil ifTrue: [^dict].
	fieldDelims := crlf asCharacterSet.
	keyValueDelim := $:.
	more := true.
	start := end := 1.
	lastKey := ''.
	[end := string indexOfAnyOf: fieldDelims startingAt: start.
	end == 0
		ifTrue: [end := string size. more := false]
		ifFalse: [end := end - 1].
	(end >= start and: [start < string size])
		ifTrue: [
			(string at: start) isSeparator
				ifTrue:
					[dict
						at: lastKey
						put: (dict at: lastKey), (string copyFrom: start to: end)]
				ifFalse:
					[colonPos := string indexOf: keyValueDelim startingAt: start.
					(colonPos > end or: [colonPos == 0])
						ifTrue:
							[key := (string copyFrom: start to: end) translateToLowercase.
							value := '']
						ifFalse:
							[key := (string copyFrom: start to: colonPos-1) translateToLowercase.
							value := (string copyFrom: colonPos+1 to: end) trimBoth]].
			key isEmpty
				ifFalse: [dict at: key put: value.
					lastKey := key.
					key := ''].
			start := string skipDelimiters: crlf startingAt: end+1].
	more] whileTrue.

	^dict! !

!HttpRequest methodsFor: '*ComanchePatch' stamp: 'sebastiansastre 1/8/2014 09:46'!
initStatusString: aString 
	| statusLine |
	statusLine := aString findTokens: ' '.
	(statusLine size between: 2 and: 3) 
		ifTrue: 
			[self method: statusLine first.
			rawUrl := statusLine second.
			url := (rawUrl copyUpTo: $?) urlDecoded.
			url size + 1 < rawUrl size 
				ifTrue: [self queryString: (rawUrl copyFrom: url size + 2 to: rawUrl size)].
			self protocol: statusLine third asUppercase]
		ifFalse: [^self error: 'invalid http status line']! !

!HttpRequest methodsFor: '*ComanchePatch' stamp: 'SebastianSastre 1/15/2012 16:42'!
parseCookies: aString 
	"PRIVATE: Parse a string in the format:  
	Cookie: NAME1=OPAQUE_STRING1; NAME2=OPAQUE_STRING2 ..."

	| dict |
	dict := Dictionary new.
	(aString findTokens: ';') do: 
			[:pairStr | 
			| pair |
			pair := pairStr findTokens: '='.
			pair size > 0 
				ifTrue: 
					[| key value |
					key := pair first trimBoth asSymbol.
					value := pair size > 1 
						ifTrue:
							[pair second trimBoth]
						ifFalse:
							[nil].
					dict at: key put: value]
				ifFalse: 
					["self log: 'Cookie invalid pair format: ''' , pairStr , ''''"

					]].
	^dict! !
